<?php

/**
 * Implementiert die Konfiguration der allgemeinen Einstellungen der GSM-Ports
 * @author Miguel Palmer <mp@beronet.com>
 */
class GsmGeneral {
	/**
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 * @return string HTML Inhalt
	 */

	function display() {

		// args
		$m = $_GET['m'];

		require_once('/usr/fallback/beroConf.php');
		// build page content
		$name = "GSM_GENERAL_TITLE_DIS";
		include('./includes/header.php');
		$gsm_sms_table = $this->dynamic_table();
		ob_start();
		?>
		<form name='gsm_gen' id='gsm_gen' action='' class="form-horizontal" method='POST' ENCTYPE="multipart/form-data">
			<input type=hidden name=m value='<? echo $m ?>'>
			<input type=hidden name=a value='save'>
			<br>
			<? echo $gsm_sms_table; ?>
		</form>
		<script type="text/javascript">
		    $("#gsm_gen").validate();
		</script>
		<?php
		$ret .= ob_get_clean();
		//Rückgabe: Inhalt der HTML-Seite
		return $ret;
	}

	/*
	 * Smtp port wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 60 als default zurückgegeben
	 */

	function smtp_port() {
		$bc = new beroConf('root');
		if ($bc->get("root", 'smtp_port') != "")
			return $bc->get("root", 'smtp_port');
		else
			return 25;
	}

	/*
	 * POP3 port wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 60 als default zurückgegeben
	 */

	function pop3_port() {
		$bc = new beroConf('root');
		if ($bc->get("root", 'pop3_port') != "")
			return $bc->get("root", 'pop3_port');
		else
			return 110;
	}

	/*
	 * smgw-enabled wird zurückgegeben, falls in der Datenbank keinen Wert
	 * vorhanden ist, wird 60 als default zurückgegeben
	 */

	function smgw_enabled() {
		$bc = new beroConf('root');
		if ($bc->get("root", 'smgw-enabled') == 1)
			return "checked";
		else
			return "";
	}

	/*
	 * smgw_use_ssl wird zurückgegeben
	 */

	function smgw_use_ssl() {
		$bc = new beroConf('root');
		if ($bc->get("root", 'smgw_use_ssl') == 1)
			return "checked";
		else
			return "";
	}

	function codec($option, $port) {
		$options = explode("|", $option);
		$checkbox = "<fieldset class='alignleft'>";
		(in_array("1", $options) || $option == "") ? $checked = "checked" : $checked = "";
		$checkbox.="<div><input type='checkbox' name='codec" . $port . "[]'  value='1' $checked>&nbsp;full&nbsp;rate&nbsp;mode</div>";
		(in_array("2", $options) || $option == "") ? $checked = "checked" : $checked = "";
		$checkbox.="<div><input type='checkbox' name='codec" . $port . "[]'  value='2' $checked>&nbsp;enhanced&nbsp;full&nbsp;rate&nbsp;mode</div>";
		(in_array("4", $options) || $option == "") ? $checked = "checked" : $checked = "";
		$checkbox.="<div><input type='checkbox' name='codec" . $port . "[]'  value='4' $checked>&nbsp;half&nbsp;rate&nbsp;mode</div>";
		(in_array("8", $options) || $option == "") ? $checked = "checked" : $checked = "";
		$checkbox.="<div><input type='checkbox' name='codec" . $port . "[]'  value='8' $checked>&nbsp;AMR&nbsp;full&nbsp;rate&nbsp;mode</div>";
		(in_array("16", $options) || $option == "") ? $checked = "checked" : $checked = "";
		$checkbox.="<div><input type='checkbox' name='codec" . $port . "[]'  value='16' $checked>&nbsp;AMR&nbsp;half&nbsp;rate&nbsp;mode</div>";
		$checkbox.="</fieldset>";
		return $checkbox;
	}

	function save(&$ba) {
		$id = $_POST['id_upd'];
		for ($i = 0; $i < count($id); $i++) {
			$id_upd = $id[$i];
			$pin = "pin" . $id_upd;
			$pin_id = $_POST[$pin];
			$smsc = "smsc" . $id_upd;
			$smsc_id = $_POST[$smsc];
			$codec = "codec" . $id_upd;
			$codec_id = "";
			if (is_array($_POST[$codec])) {
				foreach ($_POST[$codec] as $value) {
					$codec_id .=($codec_id == "") ? "" : "|";
					$codec_id.=$value;
				}
			}
			$ba = new beroAri();
			$query_upd = $ba->update("UPDATE gsm SET pin='" . sqlite_escape_string($pin_id) . "', smsc='" . sqlite_escape_string($smsc_id) . "', codec='" . sqlite_escape_string($codec_id) . "' WHERE port='" . sqlite_escape_string($id_upd) . "'");
		}
		$table.=Helper::activate(2, true, $_GET['m'], ACTIVATE);
		return $table;
	}

	/**
	 * Erstellt die HTML Tabelle für die Einstellungen der GSM Ports
	 * @return string HTML Tabelle
	 */

	function dynamic_table() {
		//Die geänderten Werte werden gespeichert
		$bc = new beroConf('root');
		$ba = new beroAri();
		require_once("./includes/lang.php");

		if (isset($_POST['id_upd'])) {
			$table.=$this->save($ba);
		}


		if ($ba->get('gui_mode') == 'simple')
			$simple_class = 'simple';
		ob_start();
		?>
		<br>
		<p class="text-center lead" ><? echo GSM_GENERAL_TABLE_HEADER_DIS ?></p>
		<br>
		<?php
		$query = $ba->select("select * from gsm");
		while ($entry = $ba->fetch_array($query)):
			?>
			<div class="row">
				<div class='form-group col-sm-2'>

					<label class='col-sm-9 control-label'><? echo HARDWARE_PORT_DIS ?></label>
					<div class='col-sm-2'>
						<label class='control-label'><? echo $entry['port'] ?></label>
					</div>
				</div>
				<div class='form-group col-sm-3'>
					<label for='pin<? echo $entry['port'] ?>' class='col-sm-5 control-label'><? echo HARDWARE_PIN_DIS ?></label>
					<div class='col-sm-7'>
						<input type='password' class='form-control input-sm' autocomplete='off' digits='true' minlength='4' maxlength='4' 
							   name='pin<? echo $entry['port'] ?>' id='pin<? echo $entry['port'] ?>' value='<? echo$entry['pin'] ?>' >
					</div>
				</div>
				<div class='form-group col-sm-3'>
					<label for='smsc<? echo $entry['port'] ?>' class='col-sm-5 control-label'><? echo HARDWARE_SMSC_DIS ?></label>
					<div class='col-sm-7'>
						<input type='text' class='form-control input-sm' name='smsc<? echo $entry['port'] ?>' id='smsc<? echo $entry['port'] ?>' 
							   value='<? echo $entry['smsc'] ?>' checkPhoneNumber='true'>
						<input type='hidden' name='id_upd[]' value='<? echo $entry['port'] ?>'>
					</div>
				</div>
				<div class='form-group <? echo $simple_class ?> col-sm-4'>
					<label for='codec' class='col-sm-5 control-label'><? echo GSM_GENERAL_CODEC_DIS ?></label>
					<div class='col-sm-7'>
						<?php echo $this->codec($entry['codec'], $entry['port']); ?>
					</div>
				</div>
			</div>
		<hr>


		<? endwhile; ?>

		<div class='text-center'><input name='submit' class='btn btn-default' type='submit' value='<? echo BUTTON_SAVE ?>' ></div>
		<?php
		$table .= ob_get_clean();



		//Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
		return $table;
	}

}
?>
